--------------
-- Domino Deus --
--------------
-- a Domino game by Ghuntar WALDMEISTER
-- BONESET_class.lua

BoneSet =   {
            x = 0,
            y = 0,
            ratio = 1,
            hasPlayed = false,
            hasPassed = false,
            }

function BoneSet:new(obj)
        local newobject = obj or {}
        newobject.updated = true
        setmetatable(newobject, self)
        self.__index = self
        return newobject
end

function BoneSet:setCoord(x,y)
    self.x, self.y = x, y
    self.updated = true
end

function BoneSet:setRatio(ratio)
    self.ratio = ratio
    self.updated = true
end

function BoneSet:containBone(bone)
    for k,v in ipairs(self) do
        if bone:fullMatch(v) then return true, k end
    end
    return false
end

function BoneSet:pickBone(bone)
    table.insert(self,bone)
    self.updated = true
end

function BoneSet:dropBone(bone)
    local contained, index = self:containBone(bone)
    if contained
    then
        table.remove(self, index)
        self.updated = true
        return true
    else return false
    end
end

function BoneSet:giveBoneTo(bone,otherBoneSet)
    otherBoneSet:pickBone(bone)
    self:dropBone(bone)
end

function BoneSet:takeBoneFrom(bone,otherBoneSet)
    self:pickBone(bone)
    otherBoneSet:dropBone(bone)
end

-- Draw the Boneset to coord x, y and adjust it to the ratio
function BoneSet:draw()
    if self.updated
    then
        self.ratio = love.graphics.getWidth( ) / #self / 64
        if self.ratio > 0.5 then self.ratio = 0.5 end
        for k,v in ipairs(self) do
            v:setCoord(self.x+(k-1)*self.ratio*70+32*self.ratio,self.y)
        end
    end

    if #self > 0 
    then
        -- love.graphics.print("    BoneSet size ="..tostring(#self)..". Ratio = "..ratio..".",x-32,y-32)
        for k,v in ipairs(self) do
        v:draw(self.ratio,halfPi)
        end
    else
        -- love.graphics.print("    BoneSet is empty.",x-32,y-32)
    end
end
