--------------
-- Domino Deus --
--------------
-- a Domino game by Ghuntar WALDMEISTER
-- BONE_class.lua




Bone = {}

-- Loading of the domino image
Bone.dominoSpriteSheet = love.graphics.newImage("dominos.png")
-- Creating the different faces
Bone.dominoFace = {}
Bone.dominoFace[0] = love.graphics.newQuad( 0, 0, 64, 64, 192, 192 )
Bone.dominoFace[1] = love.graphics.newQuad( 64, 0, 64, 64, 192, 192 )
Bone.dominoFace[2] = love.graphics.newQuad( 128, 0, 64, 64, 192, 192 )
Bone.dominoFace[3] = love.graphics.newQuad( 0, 64, 64, 64, 192, 192 )
Bone.dominoFace[4] = love.graphics.newQuad( 64, 64, 64, 64, 192, 192 )
Bone.dominoFace[5] = love.graphics.newQuad( 128, 64, 64, 64, 192, 192 )
Bone.dominoFace[6] = love.graphics.newQuad( 0, 128, 64, 64, 192, 192 )
-- Flags
-- Bone.hovered = false
Bone.selected = false
-- Coordonates
Bone.x = 0
Bone.y = 0

function Bone:new(obj)
        local newobject = obj or {}
        setmetatable(newobject, self)
        self.__index = self
        return newobject
end

function Bone:update(dt)

end

function Bone:print(x,y)
    love.graphics.print("["..self[1].."]["..self[2].."]",x,y)
end

-- Draw a bone at his own coords
function Bone:draw(ratio,angle)
    ratio = ratio or 1
    angle = angle or 0
   if angle == (halfPi)
    then
        love.graphics.drawq(Bone.dominoSpriteSheet,Bone.dominoFace[self[1]],self.x-32*ratio,self.y-32*ratio,0,ratio,ratio)
        love.graphics.drawq(Bone.dominoSpriteSheet,Bone.dominoFace[self[2]],self.x-32*ratio,self.y+32*ratio,0,ratio,ratio)
        love.graphics.setColor(200,200,255)
        love.graphics.rectangle( "line", self.x-32*ratio, self.y-32*ratio, 64*ratio, 128*ratio )
        love.graphics.setColor(255,255,255)
    elseif angle == 0
    then
        love.graphics.drawq(Bone.dominoSpriteSheet,Bone.dominoFace[self[1]],self.x-32*ratio,self.y-32*ratio,0,ratio,ratio)
        love.graphics.drawq(Bone.dominoSpriteSheet,Bone.dominoFace[self[2]],self.x+32*ratio,self.y-32*ratio,0,ratio,ratio)
        love.graphics.setColor(200,200,255)
        love.graphics.rectangle( "line", self.x-32*ratio, self.y-32*ratio, 128*ratio, 64*ratio )
        love.graphics.setColor(255,255,255)
    end
end

-- match tests if two bones match, returns the value that matches
function Bone:match(otherBone)
    if self[1] == otherBone[1] then return(self[1]) end
    if self[1] == otherBone[2] then return(self[1]) end
    if self[2] == otherBone[1] then return(self[2]) end
    if self[2] == otherBone[2] then return(self[2]) end
    return(nil)
end

-- matchValue tests if a bone match with one value, returns the value of the bone that not matches
function Bone:matchValue(value)
    if self[1] == value then return self[2]
    elseif self[2] == value then return self[1]
    else return(false) end
end

-- fullMatch tests if the two bones bear the same values, returns a boolean
function Bone:fullMatch(otherBone)
    if self[1] == otherBone[1] and self[2] == otherBone[2] then return(true) end
    if self[1] == otherBone[2] and self[2] == otherBone[1] then return(true) end
    return(false)
end

-- isPresentInTable tests if a bone is present in a table, returns a boolean
function Bone:isPresentInTable(thatTable)
    for k,v in ipairs(thatTable) do
        if self:fullMatch(v) then return true end
    end
    return false
end

-- concact concatens two bones by their matching value, return the concatened bone
function Bone:concat(otherBone)
    if self[1] == otherBone[1] then return(Bone:new({self[2],otherBone[2]})) end
    if self[1] == otherBone[2] then return(Bone:new({self[2],otherBone[1]})) end
    if self[2] == otherBone[1] then return(Bone:new({self[1],otherBone[2]})) end
    if self[2] == otherBone[2] then return(Bone:new({self[1],otherBone[1]})) end
end

-- switch switches the two values of a bone
function Bone:switch()
    self[1],self[2]=self[2],self[1]
end

function Bone:tostring()
    return("["..self[1].."]["..self[2].."]")
end

function Bone:setCoord(x,y)
    self.x = x
    self.y = y
end
