--------------
-- Domino Deus --
--------------
-- a Domino game by Ghuntar WALDMEISTER
-- Butoon library inspired by Michael Enger's "button.lua" from "NO: A game of numbers"
-- BUTTON_class.lua

Button =    {
            hover = false, -- whether the mouse is hovering over the button
            click = false, -- whether the mouse has been clicked on the button
            text = "text",
            font = love.graphics.newFont(32),
            HighLightedColor = {100,100,245},
            textColor = {125,125,125},
            }

function Button:new(text,x,y,potential)
        local newobject = {}
        setmetatable(newobject, self)
        self.__index = self
        newobject.text = text -- the text in the button
        newobject.width = self.font:getWidth(text)
        newobject.height = self.font:getHeight()
        newobject.x = x - (newobject.width / 2)
        newobject.y = y
        newobject.potential = nil or potential
        return newobject
end

function Button:draw()

    love.graphics.setFont(self.font)
    if self.hover then love.graphics.setColor(unpack(self.HighLightedColor))
    else love.graphics.setColor(unpack(self.textColor)) end
    love.graphics.print(self.text, self.x, self.y)

end

function Button:update(dt)

    self.hover = false

    local x = love.mouse.getX()
    local y = love.mouse.getY()

    if x > self.x
        and x < self.x + self.width
        and y < self.y + self.height
        and y > self.y then
        self.hover = true
    end

end

function Button:mousepressed(x, y, button)

    if self.hover
    then
        -- if audio then
            -- love.audio.play(sound["click"])
        -- end
        return true
    else
        return false
    end
end
