--------------
-- Domino Deus --
--------------
-- a Domino game by Ghuntar WALDMEISTER
-- main.lua


require("BONE_class.lua")
require("BONESET_class.lua")
require("BONEYARD_class.lua")
require("FIELD_class.lua")
require("MENU_class.lua")
require("GAME_class.lua")

function love.load()
    -- Initialisation of a random seed based on os.time()
    math.randomseed(os.time())
    math.random()
    math.random()

    halfPi = math.pi/2
    font = love.graphics.newFont(24)
    love.graphics.setBackgroundColor( 0, 100, 0 )
    config =    {   numberOfPlayer = 3,
                    score = 0,
                }
    require("menuz.lua")
    menu = Menu:new(menuz.startMenu)
    game = false
end

function love.update(dt)
    if game then game:update(dt) end
    if menu then menu:update(dt) end
end

function love.draw()
    if game then game:draw() end
    if menu then menu:draw() end

    -- Displaying some info on the screen
    love.graphics.setColor({255,255,255})
    love.graphics.setFont()
    if game then love.graphics.print("Game",700,496) end
    if menu then love.graphics.print("Menu",700,512) end
    love.graphics.print("Score : "..config.score,700,528)
    love.graphics.print(config.numberOfPlayer.." players",700,544)
    love.graphics.print("FPS : "..love.timer.getFPS(),700,560)
    love.graphics.print(_VERSION,700,576)
end

function love.mousepressed()
    if game then game:mousepressed() end
    if menu then menu:mousepressed() end
end

function love.keypressed(key, unicode)
    if key == 'r'
    then
        love.load()
    end
    if game then game:keypressed(key, unicode) end
end
